#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define EPS 1e-7
#define ZERO(x) ((x) < EPS && (x) > -EPS)

static int line[2][1024][4];
static int conv[2][1024][4];
static int tran[1024][4];

int cmp(const void *a_, const void *b_)
{
	const int *a = a_, *b = b_;
	long long x, y;
	double aa = atan2(a[3], a[2]), ab = atan2(b[3], b[2]);
	if (!ZERO(aa-ab)) return aa < ab ? 1 : -1;
	x = (long long)a[0]*b[3]-(long long)a[1]*b[2];
	y = (long long)b[0]*b[3]-(long long)b[1]*b[2];
	if (x != y) return x < y ? 1 : -1;
	x = (long long)a[0]*b[2]+(long long)a[1]*b[3];
	y = (long long)b[0]*b[2]+(long long)b[1]*b[3];
	if (x != y) return x < y ? -1 : 1;
	return 0;
}

int main(void)
{
	int f, n[2], m[2], x[2];
	char s[1024];
nc:
	f = 0;
	n[0] = n[1] = 0;
	x[0] = x[1] = 0;
	for (;;) {
		int i, j, k, l;
		gets(s);
		if (s[0] == 0) continue;
		if (s[0] == 'Q') return 0;
		if (s[0] == 'M' || s[0] == 'L') {
			int a, b;
			sscanf(s+1, "%d %d", &a, &b);
			if (s[0] == 'L') {
				if (a > 0 || (a == 0 && b > 0)) {
					line[f][n[f]][0] = x[0];
					line[f][n[f]][1] = x[1];
					line[f][n[f]][2] = a;
					line[f][n[f]][3] = b;
				} else {
					line[f][n[f]][0] = x[0]+a;
					line[f][n[f]][1] = x[1]+b;
					line[f][n[f]][2] = -a;
					line[f][n[f]][3] = -b;
				}
				n[f]++;
			}
			x[0] += a;
			x[1] += b;
		}
		if (s[0] == 'E') {
			if (++f == 2) {
				for (i = 0; i < 2; i++) {
					qsort(line[i], n[i], 4*sizeof(int), cmp);
for (j = 0; j < n[i]; j++) {
for (k = 0; k < 4; k++) printf("%d ", line[i][j][k]);
printf("\n");
}
					printf("\n");
					for (k = 0; k < 4; k++) conv[i][0][k] = line[i][0][k];
					m[i] = 1;
					for (j = 1; j < n[i]; j++) {
						int *a = line[i][j], *b = conv[i][m[i]-1], uj[4];
						long long v[4], x, y;
						double aa = atan2(a[3], a[2]), ab = atan2(b[3], b[2]);
						if (!ZERO(aa-ab)) goto copy;
						x = (long long)a[0]*b[3]-(long long)a[1]*b[2];
						y = (long long)b[0]*b[3]-(long long)b[1]*b[2];
						if (x != y) goto copy;
						v[0] = (long long)a[0]*b[2]+(long long)a[1]*b[3];
						v[1] = (long long)(a[0]+a[2])*b[2]+(long long)(a[1]+a[3])*b[3];
						v[2] = (long long)b[0]*b[2]+(long long)b[1]*b[3];
						v[3] = (long long)(b[0]+b[2])*b[2]+(long long)(b[1]+b[3])*b[3];
						if (v[0] < v[2] && v[1] < v[2]) goto copy;
						if (v[0] > v[3] && v[1] > v[3]) goto copy;
						if (v[0] < v[2]) {
							uj[0] = a[0];
							uj[1] = a[1];
						} else {
							uj[0] = b[0];
							uj[1] = b[1];
						}
						if (v[1] > v[3]) {
							uj[2] = a[2]+a[0]-uj[0];
							uj[3] = a[3]+a[1]-uj[1];
						} else {
							uj[2] = b[2]+b[0]-uj[0];
							uj[3] = b[3]+b[1]-uj[1];
						}
						for (k = 0; k < 4; k++) conv[i][m[i]-1][k] = uj[k];
						continue;
copy:
						for (k = 0; k < 4; k++) conv[i][m[i]][k] = line[i][j][k];
						m[i]++;
					}
					qsort(conv[i], m[i], 4*sizeof(int), cmp);
for (j = 0; j < m[i]; j++) {
for (k = 0; k < 4; k++) printf("%d ", conv[i][j][k]);
printf("\n");
}
printf("\n");
				}
printf("%d %d\n", m[0], m[1]);
				if (m[0] != m[1]) goto bad;
				for (i = 0; i < m[1]; i++) {
					for (j = 0; j < 2; j++) {
						int to[4], tol[2];
						double forg, nagy, si, co, h[2];
						if (j == 0) {
							for (k = 0; k < 4; k++) to[k] = conv[1][i][k];
						} else {
							to[0] = conv[1][i][0]+conv[1][i][2];
							to[1] = conv[1][i][1]+conv[1][i][3];
							to[2] = -conv[1][i][2];
							to[3] = -conv[1][i][3];
						}
						tol[0] = to[0]-conv[0][0][0];
						tol[1] = to[1]-conv[0][0][1];
						h[0] = hypot(conv[0][0][2], conv[0][0][3]);
						h[1] = hypot(to[2], to[3]);
						nagy = (double)h[1]/(double)h[0];
						si = (double)conv[0][0][2]*to[3]-(double)conv[0][0][3]*to[2];
						si /= h[0]*h[1];
						forg = asin(si);
						co = cos(forg);
printf("forg %g si %g co %g nagy %g h0 %g %d %d h1 %g %d %d\n", forg, si, co, nagy, h[0], conv[0][0][2], conv[0][0][3], h[1], to[2], to[3]);
						for (l = 0; l < m[0]; l++) {
							double x;
							tran[l][0] = conv[0][l][0]+tol[0];
							tran[l][1] = conv[0][l][1]+tol[1];
							tran[l][0] = to[0]+(tran[l][0]-to[0])*co-(tran[l][1]-to[1])*si;
							tran[l][1] = to[1]+(tran[l][0]-to[0])*si+(tran[l][1]-to[1])*co;
							x = co*conv[0][l][2]-si*conv[0][l][3];
							x *= nagy;
printf("%lf\n", x);
							if (!ZERO(x-(int)(x+0.5))) goto bad;
							tran[l][2] = (int)(x+0.5);
							x = si*conv[0][l][2]+co*conv[0][l][3];
							x *= nagy;
printf("%lf\n", x);
							if (!ZERO(x-(int)(x+0.5))) goto bad;
							tran[l][3] = (int)(x+0.5);
							if (tran[l][2] <= 0 && (tran[l][2] != 0 || tran[l][3] <= 0)) {
								tran[l][2] *= -1;
								tran[l][3] *= -1;
								tran[l][0] -= tran[l][2];
								tran[l][1] -= tran[l][3];
							}
if (l == 0) {
printf("tran\n");
for (k = 0; k < 4; k++) printf("%d ", tran[0][k]);
printf("\n");
}
						}
						qsort(tran, m[0], 4*sizeof(int), cmp);
						for (l = 0; l < m[0]; l++) {
							for (k = 0; k < 4; k++) {
								if (tran[l][k] != conv[1][l][k]) goto next;
							}
						}
						goto good;
next:					;
					}
				}
bad:
				printf("NO\n");
				goto nc;
good:
				printf("YES\n");
				goto nc;
			} else {
				x[0] = x[1] = 0;
			}
		}
	}
}